// This file was copied from MAME and modified slightly to work with FCEUX.
// 2018 March 10

#include "../../drivers/win/portmidi/pm_common/portmidi.h"
#include        "types.h"
typedef uint8 uint8_t;

class pm_module //: public osd_module, public midi_module
{
public:

	pm_module()
		//: osd_module(OSD_MIDI_PROVIDER, "pm"), midi_module()
	{
	}
	virtual ~pm_module() { }

	virtual int init();// const osd_options &options)override;
	virtual void exit();// override;

	//virtual osd_midi_device *create_midi_device() override;
	virtual void list_midi_devices(void);// override;
};

static const int RX_EVENT_BUF_SIZE = 512;

#define MIDI_SYSEX  0xf0
#define MIDI_EOX    0xf7

class osd_midi_device_pm //: public osd_midi_device
{
public:
	osd_midi_device_pm() : pmStream(nullptr), xmit_cnt(0), last_status(0), rx_sysex(false) { }
	virtual ~osd_midi_device_pm() { }
	virtual bool open_input(const char *devname);// override;
	virtual bool open_output(const char *devname);// override;
	virtual void close();// override;
	virtual bool poll();// override;
	virtual int read(uint8_t *pOut);// override;
	virtual void write(uint8_t data);// override;

private:
	PortMidiStream *pmStream;
	PmEvent rx_evBuf[RX_EVENT_BUF_SIZE];
	uint8_t xmit_in[4]; // Pm_Messages mean we can at most have 3 residue bytes
	int xmit_cnt;
	uint8_t last_status;
	bool rx_sysex;
};
